<?php
/*
                                                                                 sync4db/sync4db.inc
                                                                                          2008-04-06
This file is part of sync4db

sync4db is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

sync4db is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

function setTable($tab,$tabliste) {
  $tab->setTable($tabliste[0]);
  if ( isset($_REQUEST["tabname"]) && in_array($_REQUEST["tabname"],$tabliste) )
    $tab->setTable($_REQUEST["tabname"]);
  else
    $_REQUEST["tabname"] = $tab->getTable();
  return $tab->getTable();
}
function setPrimaryCol($tab) {
  foreach ($tab->metadata() as $col)
    if (preg_match('/primary/',$col['flags']))
      return $tab->primaryCol=$col['name'];
}
function md5array($tab) {
  $keyList  = $tab->getCol($tab->primaryCol);
  foreach($keyList as $key) $md5array[$key] = md5(join('',preg_replace('/\r\n/',chr(10),$tab->get($key))));
  return $md5array;
}
function ColArray($tab,$colname) {
  $keyList  = $tab->getCol($tab->primaryCol);
  foreach($keyList as $key) $ColArray[$key] = $tab->get($key,$colname);
  return $ColArray;
}
function sync_local($tab,$key) {
  global $params;
  $params[5] = new XML_RPC_Value($key);
  $msg       = new XML_RPC_Message('sync.getRec', $params);
  $data      = client_sent($msg);
  $trans = array_flip(get_html_translation_table(HTML_ENTITIES));
  foreach($data as $id => $item) $data[$id]=strtr($item,$trans);
  $tab->remove($key);
  $tab->add($data);
  return $tab->get($key,$tab->primaryCol);
}
function sync_remote($tab,$key) {
  global $params;
  $params[5] = new XML_RPC_Value($key);
  $res = $tab->get($key);
  foreach($res as $id => $item) $structArray[$id]=new XML_RPC_Value(htmlentities($item));
  $params[6] = new XML_RPC_Value($structArray,'struct');
  $msg       = new XML_RPC_Message('sync.putRec', $params);
  return client_sent($msg);
}
function synclocal($dsn,$tab1) {
  global $tab2;
  $tab2->setTable($_REQUEST['sync_local']);
  $tab2->primaryCol=$tab1->primaryCol;
  $md5_local1 = md5array($tab1); if (!empty($md5_local1)) ksort(&$md5_local1);
  $md5_local2 = md5array($tab2); if (!empty($md5_local2)) ksort(&$md5_local2);
  if (isset($md5_local1) ) $array_diff1 = $md5_local1;
  if (isset($md5_local2) ) $array_diff2 = $md5_local2;
  if (isset($md5_local1) && isset($md5_local2) ) {
    $array_diff1 = array_diff_assoc($md5_local1,$md5_local2);
    $array_diff2 = array_diff_assoc($md5_local2,$md5_local1);
    }
  $out  = '<input type="hidden" id="lid1" name="lid1" value="'.$_REQUEST['lid1'].'"/>';
  $out .= '<input type="hidden" id="lid2" name="lid2" value="'.$_REQUEST['lid2'].'"/>';
  $out .= '<fieldset><legend>sync tasks</legend>';
  if ( !isset($md5_local1) && !isset($md5_local2))
    $out .= $tab1->getTable().' &harr; '.$tab2->getTable().' : both empty';
  else if (isset($md5_local1) && isset($md5_local2) && count($array_diff1) == 0 && count($array_diff2) == 0) {
    $out .= $tab1->getTable().' &harr; '.$tab2->getTable().' : no difference';
    }
    if (count($array_diff1) > 0) {
      $ts = ColArray($tab1,'ts');
      $out .= '<fieldset><legend>1 local:'.$_REQUEST['tabname'].' &rarr; local:'.$_REQUEST['sync_local'].'</legend>';
      foreach($array_diff1 as $id => $value) $out .=
      '<span title="'.$ts[$id].'"onclick="document.getElementById(\'lid1\').value=this.innerHTML;f.submit();">'.$id.'</span> ';
      $out .= '</fieldset>';
      }
    if (count($array_diff2) > 0) {
      $ts = ColArray($tab2,'ts');
      $out .= '<fieldset><legend>2 local:'.$_REQUEST['sync_local'].' &rarr; local:'.$_REQUEST['tabname'].'</legend>';
      foreach($array_diff2 as $id => $value) $out .=
      '<span title="'.$ts[$id].'"onclick="document.getElementById(\'lid2\').value=this.innerHTML;f.submit();">'.$id.'</span> ';
      $out .= '</fieldset>';
      }
    $out .= '<fieldset style="background:#66f;color:#444;font-weight:bold">'
         . '<input type="radio" name="sync" value="no" checked="checked">no sync</input>'
         . '<input type="radio" name="sync" onclick="submit()" value="go2">'.$_REQUEST['sync_local'].' &rarr; '.$_REQUEST['tabname'].'</input> '
         . '<input type="radio" name="sync" onclick="submit()" value="go1">'.$_REQUEST['tabname'].' &rarr; '.$_REQUEST['sync_local'].'</input> '
         . '<input type="radio" name="sync" onclick="submit()" value="go3">'.$_REQUEST['tabname'].' &harr; '.$_REQUEST['sync_local'].'</input> '
         . '</fieldset>';
    if ( count($array_diff1) > 0 && in_array($_REQUEST['sync'],array('go1','go3')) ) {
      $out .= '<fieldset><legend>protocol '.$_REQUEST['tabname'].' &rarr; '.$_REQUEST['sync_local'].'</legend>start...';
      foreach($array_diff1 as $id => $value) {$tab2->remove($id);$tab2->add($tab1->get($id));$out .= ' '.$id;}
      $out .= ' ...finish</fieldset>';
      if ($_REQUEST['sync'] == 'go1') $_REQUEST['sync'] = '';
      }
    if ( count($array_diff2) > 0 && in_array($_REQUEST['sync'],array('go2','go3')) ) {
      $out .= '<fieldset><legend>protocol '.$_REQUEST['sync_local'].' &rarr; '.$_REQUEST['tabname'].'</legend>start...';
      foreach($array_diff2 as $id => $value) {$tab1->remove($id);$tab1->add($tab2->get($id));$out .= ' '.$id;}
      $out .= ' ...finish</fieldset>';
      $_REQUEST['sync'] = '';
      }
  return $out . '</fieldset>';
}
function sync($dsn,$mdb2,$tab,$r_tabname) {
  global $params,$tab2;
  $params[4]  = new XML_RPC_Value($r_tabname);
  $msg        = new XML_RPC_Message('sync.getmd5', $params);
  $md5_local  = md5array($tab);    if (!empty($md5_local))  ksort(&$md5_local);
  $md5_remote = client_sent($msg); if (!empty($md5_remote)) ksort(&$md5_remote);
  if (isset($md5_local) ) $array_diff2 = $md5_local;
  if (isset($md5_remote)) $array_diff1 = $md5_remote;
  if (isset($md5_local) && isset($md5_remote) ) {
    $array_diff1 = array_diff_assoc($md5_remote,$md5_local);
    $array_diff2 = array_diff_assoc($md5_local,$md5_remote);
    }
  $out  = '<input type="hidden" id="lid" name="lid" value="'.$_REQUEST['lid'].'"/>';
  $out .= '<input type="hidden" id="rid" name="rid" value="'.$_REQUEST['rid'].'"/>';
  $out .= '<fieldset><legend>sync tasks</legend>';
  if ( !isset($md5_local) && !isset($md5_remote))
    $out .= $tabname.' &harr; '.$r_tabname.' : both empty';
  else if (isset($md5_local) && isset($md5_remote) && count($array_diff1) == 0 && count($array_diff2) == 0) {
    $out .= $tabname.' &harr; '.$r_tabname.' : no difference';
    }
  else {
    if (count($array_diff1) > 0) {
      $params[5] = new XML_RPC_Value('ts');
      $msg       = new XML_RPC_Message('sync.getCol', $params);
      $ts        = client_sent($msg);
      $out .= '<fieldset><legend>remote:'.$_REQUEST['r_tabname'].' &rarr; local:'.$_REQUEST['tabname'].'</legend>';
      foreach($array_diff1 as $id => $value) $out .=
      '<span title="'.$ts[$id].'"onclick="document.getElementById(\'rid\').value=this.innerHTML;f.submit();">'.$id.'</span> ';
      $out .= '</fieldset>';
      }
    if (count($array_diff2) > 0) {
      $ts = ColArray($tab,'ts');
      $out .= '<fieldset><legend>local:'.$_REQUEST['tabname'].' &rarr; remote:'.$_REQUEST['r_tabname'].'</legend>';
      foreach($array_diff2 as $id => $value) $out .=
      '<span title="'.$ts[$id].'" onclick="document.getElementById(\'lid\').value=this.innerHTML;f.submit();">'.$id.'</span> ';
      $out .= '</fieldset>';
      }
    $out .= '<fieldset style="background:#6F6;color:#444;font-weight:bold">'
         . '<input type="radio" name="sync" value="no" checked="checked">no sync</input>'
         . '<input type="radio" name="sync" onclick="submit()" value="go1">remote &rarr; local</input> '
         . '<input type="radio" name="sync" onclick="submit()" value="go2">local &rarr; remote</input> '
         . '<input type="radio" name="sync" onclick="submit()" value="go3">local &harr; remote</input> '
         . '<input type="radio" name="sync" onclick="submit()" value="go4">remote &minus; local &rarr; out</input> '
         . '<input type="radio" name="sync" onclick="submit()" value="go5">local &minus; remote &rarr; out</input> '
         . '</fieldset>';
    if ( in_array($_REQUEST['sync'], array('go4','go5')) ){
      $mdb2->query('CREATE TABLE '.$tab->getTable().'_delta LIKE '.$tab->getTable());
      $tab_2->setTable($tab->getTable().'_delta'); $tab_2->primaryCol=$tab->primaryCol;
      }
    if ( count($array_diff1) > 0 && in_array($_REQUEST['sync'],array('go1','go3','go4')) ) {
      $out .= '<fieldset><legend>protocol remote &rarr; local</legend>start...';
      foreach($array_diff1 as $id => $value)
        if ($_REQUEST['sync']=='go4')   $out .= ' '.sync_local($tab_2,$id);
        else                            $out .= ' '.sync_local($tab,$id);
      $out .= ' ...finish</fieldset>';
      if (in_array($_REQUEST['sync'],array('go1','go4'))) $_REQUEST['sync']='';
      }
    if (count($array_diff2) > 0 && in_array($_REQUEST['sync'],array('go2','go3','go5')) ) {
      $out .= '<fieldset><legend>protocol local &rarr; remote</legend>start...';
      foreach($array_diff2 as $id => $value)
        if ($_REQUEST['sync']=='go5')  {$tab_2->remove($id);$tab_2->add($tab->get($id));$out.=' '.$id;}
        else                            $out .= ' '.sync_remote($tab,$id);
      $out .= ' ...finish</fieldset>';
      $_REQUEST['sync']='';
    }
  }
  return $out . '</fieldset>';

}
function getHTMLProlog() {
  return '<?xml version="1.0" encoding="ISO-8859-1" ?>'
       . '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'
       . '<html xmlns="http://www.w3.org/1999/xhtml">'
       . '<head><title>sync4db</title>'
       . '<meta name="copyright" content="2007 by BTC Weiterbildung Wolfgang Kowalski"/>'
       . '<meta name="author" content="Wolfgang Kowalski" />'
       . '<meta name="description" content="sync4db ist ein kleines aber feines Web-Datenbank-Synchronisations-Tool"/>'
       . '<style>body,.f,input{font-family:Calibri,sans-serif;font-size:14px;}
                 legend,a{color:#fff}.i{width:70px}.j{width:120px}fieldset{padding:8px}
                 span{cursor:pointer;}</style>'
       . '</head><body style="background:#444;color:#fff">'
       . '<div style="font-size:42px;font-weight:bold;text-align:right;margin-top:-10px">sync4db</div>'
       . '<div style="font-size:10px;text-align:right;color:#999;">&copy; 2007 btc-weiterbildung.de</div>';
}
function getCount($tab,$tabname) {
  $tab->setTable($tabname);
  return $tab->getCount();
}
function getHTMLTabList($tab,$tabliste) {
  $org_tabname = $tab->getTable();
  $out = '<fieldset><legend title="numbers show the count of records">local tables @ '.$_REQUEST['dbname'].'</legend>';
  foreach($tabliste as $tabname)
    $out .= '<input type="radio" name="tabname" onclick="submit()" value="'.$tabname.'" '
         .  ($_REQUEST['tabname']==$tabname?'checked="checked"> ':'> ').$tabname.'['.getCount($tab,$tabname).']';
  $tab->setTable($org_tabname);
  return $out . '<br/><br/>';
}
function getRemoteHTMLTabList() {
  global $params,$dbname;
  $msg  = new XML_RPC_Message('sync.getTabList', $params);
  $resp = client_sent($msg);
  $out  = '<fieldset><legend title="numbers show the count of records">remote tables @ '.$dbname.'</legend> ';
  foreach($resp as $item)
    $out .= '<input type="radio" name="r_tabname"  onclick="submit()" value="'.$item['tabname'].'" '
         .  ($_REQUEST['r_tabname']==$item['tabname']?'checked="checked"/> ':'/> ')
         .$item['tabname'].'['.$item['tabcount'].']';
    return $out . '<br/><br/>';
}
function getServer() {
  global $server_url;
  return '<fieldset><legend>sync4db_server @ '.$server_url.'</legend>'
       . '<input type="text" size="64" ondblclick="submit()" onchange="submit()" name="server_url" value="'
       . $_REQUEST['server_url'].'" title="URL to sync4db_server.php, which could connect to the remote database"></input>'
       . '</fieldset>';
}
function getHTMLDBList($mdb2) {
  $DBList = $mdb2->mgListDatabases();
  $out = '<fieldset><legend>local databases @ http://localhost</legend>';
  foreach($DBList as $dbname)
    if ($dbname <> 'information_schema' && $dbname <> 'mysql')
      $out .= '<input type="radio" name="dbname" onclick="submit()" value="'.$dbname.'" '
           .  ($_REQUEST['dbname']==$dbname?'checked="checked"> ':'> ').$dbname;
  return $out . '</fieldset>';
}
function client_sent($msg,$debug=false){
  global $server_path,$server_url,$port,$HTTP_username,$HTTP_password;
  $cli = new XML_RPC_Client($server_path, $server_url, $port);
  //$msg->setSendEncoding('ISO-8859-1');
  if ($debug) $cli->setDebug(1);
  $cli->setCredentials($HTTP_username,$HTTP_password);      // if you setup server basic authentification
  $resp = $cli->send($msg);
  if (!$resp) { echo 'Communication error: ' . $cli->errstr; exit; }
  if (!$resp->faultCode()) return XML_RPC_decode($resp->value());
  else print 'Fault Code: '.$resp->faultCode().' Fault Reason: '.$resp->faultString().'<br/>';
}