<?php
require_once '_db/ini.db.inc';
require_once 'XML/RPC/Server.php';
require_once 'MDB2.php';
require_once 'MDB/QueryTool.php';

                       $app      = 'sync4db';
if (!isset($username)) $username = 'username';              // modify !!!
if (!isset($password)) $password = 'password';              // modify !!!
if (!isset($dbname))   $dbname   = substr($dsn,strrpos($dsn,"/")+1);

class Tabelle extends MDB_QueryTool {};
$mdb2     =& MDB2::factory($dsn);
define('MDB2',2);
$tab      = new Tabelle($dsn,$options=array(),MDB2);        // 1 = MDB, 2 = MDB2

function testaccess($params) {                              // check application, username and password
  global $app, $username, $password;
  $a = XML_RPC_decode($params->getParam(0));
  $u = XML_RPC_decode($params->getParam(1));
  $p = XML_RPC_decode($params->getParam(2));
  $d = XML_RPC_decode($params->getParam(3));
  if ("$a" == $app && "$u" == $username && "$p" == md5($password)) return true;
  else die();
}
function getPrimColName($tab) {
  foreach ($tab->metadata() as $col)
    if (preg_match('/primary/',$col['flags']))
      return $col['name'];
}
function getDBName($params) {
  testaccess($params);
  global $mdb2,$tab;
  return new XML_RPC_Response(new XML_RPC_Value($dbname));
}
function getTabList($params) {
  testaccess($params);
  global $mdb2,$tab;
  $tabliste = $mdb2->mgListTables();
  foreach($tabliste as $tabname) {
    $tab->setTable($tabname);
    $structArray[] =  new XML_RPC_Value(array(
      'tabname'        => new XML_RPC_Value($tabname),
      'tabcount'       => new XML_RPC_Value($tab->getCount()),
      ), 'struct');
    }
  return new XML_RPC_Response(new XML_RPC_Value($structArray,'array'));
}
function removeTab($params) {
  testaccess($params);
  $tabname  = XML_RPC_decode($params->getParam(4));
  global $mdb2;
  $mdb2->query('DROP TABLE '.$tabname);
  return new XML_RPC_Response(new XML_RPC_Value(true,'boolean'));
}
function truncateTab($params) {
  testaccess($params);
  $tabname  = XML_RPC_decode($params->getParam(4));
  global $mdb2;
  $mdb2->query('TRUNCATE TABLE '.$tabname);
  return new XML_RPC_Response(new XML_RPC_Value(true,'boolean'));
}
function renameTab($params) {
  testaccess($params);
  $tabname  = XML_RPC_decode($params->getParam(4));
  $newname  = XML_RPC_decode($params->getParam(5));
  if ($tabname == $newname) return new XML_RPC_Response('',801,'renameTab: wrong name');
  global $mdb2;
  $mdb2->query('RENAME TABLE '.$tabname.' TO '.$newname);
  return new XML_RPC_Response(new XML_RPC_Value($newname));
}
function cloneTab($params) {
  testaccess($params);
  $tabname  = XML_RPC_decode($params->getParam(4));
  $newname  = XML_RPC_decode($params->getParam(5));
  if ($tabname == $newname) return new XML_RPC_Response('',801,'cloneTab: wrong name');
  global $mdb2;
  $mdb2->query('CREATE TABLE '.$newname.' LIKE '.$tabname);
  return new XML_RPC_Response(new XML_RPC_Value($newname));
}
function copyTab($params) {
  testaccess($params);
  $tabname  = XML_RPC_decode($params->getParam(4));
  $newname  = XML_RPC_decode($params->getParam(5));
  if ($tabname == $newname) return new XML_RPC_Response('',801,'copyTab: wrong name');
  global $mdb2;
  $mdb2->query('INSERT INTO '.$newname.' SELECT * FROM '.$tabname);
  return new XML_RPC_Response(new XML_RPC_Value($newname));
}
function cloneTabFromLocal($params) {
  testaccess($params);
  $tabname  = XML_RPC_decode($params->getParam(4));
  $tstruct  = XML_RPC_decode($params->getParam(5));
  global $mdb2;
  $mdb2->query('CREATE TABLE '.$tabname.' '.$tstruct);
  return new XML_RPC_Response(new XML_RPC_Value($tabname));
}
function cloneTabFromRemote($params) {
  testaccess($params);
  $tabname  = XML_RPC_decode($params->getParam(4));
  global $mdb2;
  $data     = $mdb2->queryAll('SHOW CREATE TABLE '.$tabname);
  $tstruct  = preg_replace('/^.*?(\(.*)/','\\1',$data[0][1]);
  return new XML_RPC_Response(new XML_RPC_Value($tstruct));
}
function getmd5($params) {
  testaccess($params);
  $tabname  = XML_RPC_decode($params->getParam(4));
  global $tab;
  $tab->setTable($tabname);
  if ($tab->getCount() == 0) return new XML_RPC_Response(new XML_RPC_Value(array(),'struct'));
  $tab->primaryCol=getPrimColName($tab);
  $keyList  = $tab->getCol($tab->primaryCol);
  foreach($keyList as $id)
    $structArray[$id] = new XML_RPC_Value(md5(join('',preg_replace('/\r\n/',chr(10),$tab->get($id)))));
  return new XML_RPC_Response(new XML_RPC_Value($structArray,'struct'));
}
function getCol($params) {
  testaccess($params);
  $tabname  = XML_RPC_decode($params->getParam(4));
  $colname  = XML_RPC_decode($params->getParam(5));
  global $tab;
  $tab->setTable($tabname);
  if ($tab->getCount() == 0) return new XML_RPC_Response(new XML_RPC_Value(array(),'struct'));
  $tab->primaryCol=getPrimColName($tab);
  $keyList  = $tab->getCol($tab->primaryCol);
  foreach($keyList as $id)
    $structArray[$id] = new XML_RPC_Value($tab->get($id,$colname));
  return new XML_RPC_Response(new XML_RPC_Value($structArray,'struct'));
}
function getRec($params) {
  testaccess($params);
  $tabname  = XML_RPC_decode($params->getParam(4));
  $key      = XML_RPC_decode($params->getParam(5));
  global $tab;
  $tab->setTable($tabname);
  $tab->primaryCol=getPrimColName($tab);
  $res = $tab->get($key);
  foreach($res as $id => $item) $structArray[$id]=new XML_RPC_Value(htmlentities($item));
  return new XML_RPC_Response(new XML_RPC_Value($structArray,'struct'));
}
function putRec($params) {
  testaccess($params);
  $tabname  = XML_RPC_decode($params->getParam(4));
  $key      = XML_RPC_decode($params->getParam(5));
  $data     = XML_RPC_decode($params->getParam(6));
  global $dsn,$mdb2,$tab;
  $tab->setTable($tabname);
  $tab->primaryCol=getPrimColName($tab);
  $mdb2->mgListTables();
  if (!in_array($tabname.'_remove',$mdb2->mgListTables()))  // create backup tab
    $mdb2->query('CREATE TABLE '.$tabname.'_remove LIKE '.$tabname);
  class Tabelle1 extends MDB_QueryTool {};
  $tab1     = new Tabelle1($dsn,array(),2);
  $tab1->setTable($tabname.'_remove');                      // open backup tab
  foreach($data as $id => $item) $data[$id]=html_entity_decode($item);
  if (!$res=$tab->get($key))                                // test for update
     { $tab->add($data); }
  else                                                      // backup, remove, add
     { $tab1->add($data); $tab->remove($key); $tab->add($data); }
  return new XML_RPC_Response(new XML_RPC_Value($tab->get($key,$tab->primaryCol)));
}

$server = new XML_RPC_Server(array(
  'sync.getDBName'            => array('function' => 'getDBName'),
  'sync.getTabList'           => array('function' => 'getTabList'),
  'sync.removeTab'            => array('function' => 'removeTab'),
  'sync.truncateTab'          => array('function' => 'truncateTab'),
  'sync.renameTab'            => array('function' => 'renameTab'),
  'sync.cloneTab'             => array('function' => 'cloneTab'),
  'sync.copyTab'              => array('function' => 'copyTab'),
  'sync.cloneTabFromLocal'    => array('function' => 'cloneTabFromLocal'),
  'sync.cloneTabFromRemote'   => array('function' => 'cloneTabFromRemote'),
  'sync.getmd5'               => array('function' => 'getmd5'),
  'sync.getCol'               => array('function' => 'getCol'),
  'sync.getRec'               => array('function' => 'getRec'),
  'sync.putRec'               => array('function' => 'putRec')
  ),1);
?>